import { JsonRpcEngine } from "@metamask/json-rpc-engine";
import { providerFromEngine } from "./provider-from-engine.mjs";
/**
 * Construct an Ethereum provider from the given middleware.
 *
 * @param middleware - The middleware to construct a provider from.
 * @returns An Ethereum provider.
 */
export function providerFromMiddleware(middleware) {
    const engine = new JsonRpcEngine();
    engine.push(middleware);
    const provider = providerFromEngine(engine);
    return provider;
}
//# sourceMappingURL=provider-from-middleware.mjs.map